package ecommerce;

import framework.DomainException;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author  pfister
 */
public class Application {
	private List<Client> clients = new ArrayList<Client>();
	private List<CodePostal> codesPostaux = new ArrayList<CodePostal>();
    private List<Produit> produits = new ArrayList<Produit>();

	public Caddie addCaddie(Client client, double montant, String date)
			throws DomainException {
		Caddie toAdd = new Caddie(client.getCaddies().size()+1,client, montant, date);
		client.getCaddies().add(toAdd);
		return toAdd;
	}

	public Client addClient(String nom, String adresse, CodePostal codePostal) throws DomainException {
		Client toAdd = new Client(clients.size() + 1, nom, adresse,codePostal);
		if (clients.contains(toAdd))
			throw new DomainException("le client existe dj");		
		clients.add(toAdd);
		return toAdd;
	}

	

	public CodePostal addCodePostal(String code,String nom){
		CodePostal toAdd = new CodePostal(codesPostaux.size()+1,code,nom);
		codesPostaux.add(toAdd);
		return toAdd;
	}
	
	
	public Produit addProduit(int id,String nom,double prix){
		Produit toAdd = new Produit(id,nom,prix);
		produits.add(toAdd);
		return toAdd;
	}	
	
	public List<Produit> getProduits() {
		return produits;
	}	
	
	
	/**
	 * @return  the clients
	 * @uml.property  name="clients"
	 */
	public List<Client> getClients() {
		return clients;
	}

	public static void main(String[] args) {
		Application eCommerce = new Application();
		eCommerce.test();
	}

	@Override
	public String toString() {
		String result = "";
		result += "------clients-factures-------\n";
		Iterator clientIterator = clients.iterator();
		while (clientIterator.hasNext()) {
			Client client = (Client) clientIterator.next();
			result += client.toString() + "\n";
		}
		return result;
	}

	public void test() {
        load();
		System.out.print(this);
	}

	public void load() {
		try {

			Produit p1 = addProduit(1, "th", 10.0);
			Produit p2 = addProduit(2, "caf", 20.0);
			Produit p3 = addProduit(3, "chocolat", 30.0);
			
			CodePostal c1 = addCodePostal("30000","Nmes");
			CodePostal c2 = addCodePostal("30100","Als");
			CodePostal c3 = addCodePostal("34000","Montpellier");

			Client client1 = addClient("Dupont", "10, rue des roses",c1);
			Client client2 = addClient("Durand", "15, rue des lilas",c2);

			Caddie caddie = addCaddie(client1, 100.0, "10/02/2005");
			caddie = addCaddie(client1, 200.0, "01/04/2005");
			caddie = addCaddie(client1, 300.0, "12/06/2006");
			caddie = addCaddie(client2, 250.0, "15/02/2000");
			caddie = addCaddie(client2, 350.0, "15/03/2000");
			
			
		

		} catch (DomainException e) {
			System.out.print(e.getMessage());
			e.printStackTrace();
		}
		
	}

	public void save() {
		// TODO Auto-generated method stub
		
	}

	public List<CodePostal> getCodesPostaux() {
		return codesPostaux;
	}




	
}
