package ecommerce;

import framework.DomainException;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author  pfister
 */

public class Client implements Bean{

	private int id;
	private List<Caddie> caddies = new ArrayList<Caddie>();
	private CodePostal codePostal;
	private String error;
	private String nom;
	private String adresse;

	
	/**
	 * @return  the caddies
	 * @uml.property  name="caddies"
	 */
	public List<Caddie> getCaddies() {
		return caddies;
	}	
	
	/**
	 * @return  the adresse
	 * @uml.property  name="adresse"
	 */
	public String getAdresse() {
		return adresse;
	}
	/**
	 * @param adresse  the adresse to set
	 * @uml.property  name="adresse"
	 */
	public void setAdresse(String adresse) {
		this.adresse = adresse;
	}

	/**
	 * @return  the nom
	 * @uml.property  name="nom"
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param nom  the nom to set
	 * @uml.property  name="nom"
	 */
	public void setNom(String nom) {
		if ("foobar".equals(nom)) // simuler une erreur mtier
	           throw new RuntimeException("nom foobar est interdit pour client");		
		if ("barzoo".equals(nom)) // simuler une erreur mtier
	           error = "nom barzoo est interdit pour client";		
		this.nom = nom;
	}
	/**
	 * @return  the id
	 * @uml.property  name="id"
	 */
	public int getId() {
		return id;
	}
	/**
	 * @param id  the id to set
	 * @uml.property  name="id"
	 */
	public void setId(int id) {
		this.id = id;
	}
	
	public Client(int id, String nom, String adresse, CodePostal codePostal) {
		super();
		if ("foobar".equals(nom)) // simuler une erreur mtier, mthode 1: erreur fatale
	           throw new RuntimeException("nom foobar est interdit pour client");	
		if ("barzoo".equals(nom)) // simuler une erreur mtier, mthode 2: erreur gre par une proprit error du bean
	           error = "nom barzoo est interdit pour client";		
		this.id = id;
		this.nom = nom;
		this.adresse = adresse;
		this.codePostal = codePostal;
	}
	
	public Caddie addCaddie(double montant, String date) throws DomainException {
		Caddie toAdd=new Caddie(caddies.size()+2,this,montant,date);
		caddies.add(toAdd);	
		return toAdd;
	}
	
	@Override
	public String toString() {
		String result = "Client:  "+nom+" "+adresse+"cp "+codePostal.getCode();
		Iterator caddieIterator = caddies.iterator();
		while (caddieIterator.hasNext()) {
			Caddie caddie = (Caddie) caddieIterator.next();
			result += "\n"+caddie.toString(); 
		}
		return result;
	}

	public String getError() {
		return error;
	}

	public void clearError() {
		this.error = null;
	}
	
	public Object clone() throws CloneNotSupportedException{
		return new Client(id,nom,adresse,codePostal);	
	}

	public CodePostal getCodePostal() {
		return codePostal;
	}

	public void setCodePostal(CodePostal codePostal) {
		this.codePostal = codePostal;
	}	
	
	//TODO un  comparateur pour trier
	

	
}
