package framework;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import ecommerce.Application;
import ecommerce.Bean;


/**
 * 
 * @author gsi-4a
 * reprsente l'tat d'une requte pour distribution aux sous-contrleurs
 * permet de revenir au contexte n-1 en cas d'erreur systme ou mtier
 */
public class ActionContext{
	private Application application;
	private HttpServletRequest request;
	private String action; 
	private String priorAction;
	private String state;
	private String priorState;
	private String error;
	private Bean bean;
	private Bean saved;
	public String getError() {
		return error;
	}
	public void setError(String error) {
		if (error==null)
			this.error="error";
		else
		    this.error = error;
		action = priorAction;
		if (action == null)
			action = "null";
		state = priorState;
//		 revenir  la page et tat et bean o s'est produite l'erreur
	}
	
	public String getAction() {
		return action;
	}
	public Application getApplication() {
		return application;
	}
	public String getPriorAction() {
		return priorAction;
	}
	public String getPriorState() {
		return priorState;
	}
	public HttpServletRequest getRequest() {
		return request;
	}
	public String getState() {
		return state;
	}
	
	public void initialize(HttpServletRequest request,Application application,  String priorAction,String action, String priorState, String state) {
		this.application = application;
		this.request = request;
		this.action = action;
		this.priorAction = priorAction;
		this.state = state;
		this.priorState = priorState;
		this.error = null;
	}
	
	public void setAction(String action) {
		this.action = action;
	}
	
	public void setState(String state) {
		if (bean!=null && bean.getError() != null)
			setError(bean.getError());
		else
		  this.state = state;
	}
		
	public void setBean(Bean bean)throws CloneNotSupportedException {
		   this.bean = bean;
	}
	
	public Bean getBean() {
		return bean;
	}
	public Bean getSaved() {
		return saved;
	}
	
	public void saveBeanIfClean(Bean bean)throws CloneNotSupportedException {
		if (bean != null && bean.getError() == null)
		  this.saved = (Bean)bean.clone();
	}	
	
	public Bean cancel(List beans){
		if (bean != null && bean.getError()!=null && saved!=null)
			return replaceBean(beans);
		else if (bean == null && saved != null)
			bean = saved;
		return bean;
	}
		
	private Bean replaceBean(List beans) {
		Iterator bs=beans.iterator();
		Bean b = null;
		while (bs.hasNext()) {
			b = (Bean) bs.next();
			if (b.getId() == saved.getId())
				break;
		}
		beans.remove(b);
		beans.add(saved);
		bean = saved;
		return bean;
	}
}
