package framework;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

/**
 * 
 * @author gsi-4a 
 * Modifie une request avant redirection Normalise le paramtre
 *         action dont le libell varie selon les libells des boutons submit
 *         selon les langues
 * 
 */
public class ActionRequestWrapper extends HttpServletRequestWrapper {
	public final static int LANG_FRENCH = 1;

	public final static int LANG_GERMAN = 2;

	public final static int LANG_ENGLISH = 3;

	private String action;

	private int language;

	public ActionRequestWrapper(HttpServletRequest request, int language) {
		super(request);
		this.action = request.getParameter("action");
		this.language = language;
	}

	private String normalizeFrench(String action) {
		if ("modifier".equals(action) || "confirmer".equals(action)
				|| "ok".equals(action))
			action = "confirm";
		else if ("edite".equals(action))
			action = "edit";
		else if ("ajouter".equals(action))
			action = "new";
		else if ("supprimer".equals(action))
			action = "delete";
		else if ("rechercher".equals(action))
			action = "retrieve";
		else if ("annuler".equals(action))
			action = "cancel";
		else if ("liste".equals(action))
			action = "list";
		return action;
	}

	// confirmer

	private String normalizeGerman(String action) {
		if ("ndern".equals(action) || "besttigen".equals(action)
				|| "ok".equals(action))
			action = "confirm";
		else if ("editieren".equals(action))
			action = "edit";
		else if ("hinzufgen".equals(action))
			action = "new";
		else if ("lschen".equals(action))
			action = "delete";
		else if ("suchen".equals(action))
			action = "retrieve";
		else if ("abbrechen".equals(action))
			action = "cancel";
		else if ("listen".equals(action))
			action = "list";
		return action;
	}

	private String normalizeEnglish(String action) {
		if ("modify".equals(action) || "confirm".equals(action)
				|| "ok".equals(action))
			action = "confirm";
		else if ("edit".equals(action))
			action = "edit";
		else if ("add".equals(action))
			action = "new";
		else if ("delete".equals(action))
			action = "delete";
		else if ("find".equals(action))
			action = "retrieve";
		else if ("cancel".equals(action))
			action = "cancel";
		else if ("list".equals(action))
			action = "list";
		return action;
	}

	public String getParameter(String name) {
		if (name.equals("action")) {
			switch (language) {
			case LANG_FRENCH:
				return normalizeFrench(action);
			case LANG_ENGLISH:
				return normalizeEnglish(action);
			case LANG_GERMAN:
				return normalizeGerman(action);
			default:
				return action;
			}
		} else
			return super.getParameter(name);
	}
}
