package framework;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 
 * @author gsi-4a
 * controleur unique de l'application
 *
 */

public abstract class Controleur extends javax.servlet.http.HttpServlet implements
		javax.servlet.Servlet {


	
	protected abstract void actions(String path,ActionContext c);
	
	protected abstract void setContext(ActionContext context, HttpServletRequest request, String priorAction,String action,String etatCourant,String etatSuivant);

	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		String servletPath = request.getServletPath();
		String path = "";
		if (servletPath.indexOf(".do") != -1)
			path = servletPath.substring(1, servletPath.indexOf(".do"));
		String etatCourant = (String) request.getSession().getAttribute(
				"etatCourant");
		String priorAction = (String) request.getSession().getAttribute(
				"priorAction");
		if (etatCourant == null)
			etatCourant = "initial";

		request = new ActionRequestWrapper(request,
				ActionRequestWrapper.LANG_FRENCH);
		String action = request.getParameter("action");
		String etatSuivant = null;
		ActionContext context = getActionContext(request);
		setContext(context, request, priorAction, action, etatCourant, etatSuivant);
		actions(path,context);
        if (context.getError()!=null)
        	request.setAttribute("error", context.getError());
        etatSuivant = context.getState();
        action = context.getAction();
        if ("initial".equals(etatSuivant))
        	etatSuivant = "index.jsp";
    	if (etatSuivant == null)
			etatSuivant="error.jsp";
        request = new ActionRequestWrapper(request,
				ActionRequestWrapper.LANG_FRENCH);
		request.getSession().setAttribute("etatCourant", etatSuivant);
		request.getSession().setAttribute("priorAction", action);
		WorkflowHistory w = getworkflowHistory(request);
		w.add(request.getParameter("id"), path, priorAction, RequestLog.getRefererParameter(request, "action"), action, etatCourant, etatSuivant, context.getError());
		request.setAttribute("controler-log", w.getReverseHistory());
		RequestDispatcher dispatcher = request
				.getRequestDispatcher(etatSuivant);
		dispatcher.forward(request, response);
	}

	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

	private ActionContext getActionContext(HttpServletRequest request){
		ActionContext result = null;
		Object ac = request.getSession().getAttribute("action-context");
		if (ac != null)
			result = (ActionContext)ac;	
		else{
			result = new ActionContext();
		    request.getSession().setAttribute("action-context",result);
		}
		return result;		
	}
	
	private WorkflowHistory getworkflowHistory(HttpServletRequest request){
		WorkflowHistory result = null;
		Object wf = request.getSession().getAttribute("workflow-history");
		if (wf != null)
			result = (WorkflowHistory)wf;	
		else{
			result = new WorkflowHistory();
		    request.getSession().setAttribute("workflow-history",result);
		}
		return result;		
	}	
	



	
}