package framework;

import java.io.IOException;
import java.util.StringTokenizer;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class RequestLog {

	public static String getRefererParameter(HttpServletRequest request,
			String paramName) {
		String result = "";
		String host = request.getHeader("host");
		String referer = request.getHeader("referer");
		if (referer != null) {
			String contextPath = request.getContextPath();
			String root = "http://" + host + contextPath;
			String refererRequest = referer.substring(root.length() + 1);
			if (refererRequest.length() > 4) {
				String refererQuery = refererRequest.substring(refererRequest
						.indexOf(".do?") + 4);
				StringTokenizer st = new StringTokenizer(refererQuery, "&");
				while (st.hasMoreTokens()) {
					String pair = st.nextToken();
					String name = null, value = null;
					int eq = pair.indexOf("=");
					if (eq != -1) {
						value = pair.substring(eq + 1);
						name = pair.substring(0, eq);
					} else
						name = pair.substring(0, pair.length() - 1);
					if (paramName.equals(name)){
						result = value;
						break;
					}
				}
			}
		}
		return result;
	}

	public static String debug(javax.servlet.http.HttpServlet servlet,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		boolean tb = false;
		StringBuffer buffer = new StringBuffer();

		buffer.append("\n<br/>").append(
				"request is " + request.getRequestURI() + "?"
						+ request.getQueryString());

		buffer.append("\n<br/>").append(
				"***************context.getInitParameterNames");

		java.util.Enumeration en = servlet.getServletContext()
				.getInitParameterNames();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			if (key.indexOf("javax.servlet.include") > -1)
				tb = true;
			Object value = servlet.getServletContext().getInitParameter(key);

			buffer.append("\n<br/>").append("   " + key + " = " + value);
		}

		buffer.append("\n<br/>").append(
				"***************context.getAttributeNames");
		en = servlet.getServletContext().getAttributeNames();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			if (key.indexOf("javax") > -1)
				tb = true;

			if (key.indexOf("javax.servlet.include") > -1)
				tb = true;

			Object value = servlet.getServletContext().getAttribute(key);

			buffer.append("\n<br/>").append("   " + key + " = " + value);
		}

		buffer.append("\n<br/>").append(
				"***************context.getAttributeNames");

		en = request.getAttributeNames();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			if (key.indexOf("javax.servlet.include") > -1)
				tb = true;

			Object value = request.getAttribute(key);

			buffer.append("\n<br/>").append("   " + key + " = " + value);
		}

		buffer.append("\n<br/>")
				.append("***************context.getHeaderNames");

		en = request.getHeaderNames();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			if (key.indexOf("javax.servlet.include") > -1)
				tb = true;

			String value = request.getHeader(key);

			buffer.append("\n<br/>").append("   " + key + " = " + value);
		}

		buffer.append("\n<br/>").append("***************misc");

		buffer.append("\n<br/>").append(
				"Servlet Name: " + servlet.getServletName());

		buffer.append("\n<br/>").append(
				"Protocol: " + request.getProtocol().trim());

		buffer.append("\n<br/>").append("Scheme: " + request.getScheme());

		buffer.append("\n<br/>").append(
				"Server Name: " + request.getServerName());

		buffer.append("\n<br/>").append(
				"Server Port: " + request.getServerPort());

		buffer.append("\n<br/>").append(
				"Server Info: " + servlet.getServletContext().getServerInfo());

		buffer.append("\n<br/>").append(
				"Remote Addr: " + request.getRemoteAddr());

		buffer.append("\n<br/>").append(
				"Remote Host: " + request.getRemoteHost());

		buffer.append("\n<br/>").append(
				"Character Encoding: " + request.getCharacterEncoding());

		buffer.append("\n<br/>").append(
				"Content Length: " + request.getContentLength());

		buffer.append("\n<br/>").append(
				"Content Type: " + request.getContentType());

		buffer.append("\n<br/>").append("Locale: " + request.getLocale());

		buffer.append("\n<br/>").append(
				"Default Response Buffer: " + response.getBufferSize());

		buffer.append("\n<br/>").append(
				"Request Is Secure: " + request.isSecure());

		buffer.append("\n<br/>").append("Auth Type: " + request.getAuthType());

		buffer.append("\n<br/>").append("HTTP Method: " + request.getMethod());

		buffer.append("\n<br/>").append(
				"Remote User: " + request.getRemoteUser());

		buffer.append("\n<br/>").append(
				"Request URI: " + request.getRequestURI());

		buffer.append("\n<br/>").append(
				"Context Path: " + request.getContextPath());

		buffer.append("\n<br/>").append(
				"Servlet Path: " + request.getServletPath());

		buffer.append("\n<br/>").append("Path Info: " + request.getPathInfo());

		buffer.append("\n<br/>").append(
				"Path Trans: " + request.getPathTranslated());

		buffer.append("\n<br/>").append(
				"Query String: " + request.getQueryString());

		return buffer.toString();

	}

}
