package framework;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


/**
 * 
 * @author gsi-4a
 * Historise la navigation web au format html
 *
 */

public class WorkflowHistory {
	private List<WorkflowLog> lines = new ArrayList<WorkflowLog>();
	private int count;

	public void add(String id, String path, String priorAction,
			 String refererAction, String action,
			String etatCourant, String etatSuivant, String error) {
		lines.add(new WorkflowLog(count++, id, path, priorAction, 
				refererAction, action, etatCourant, etatSuivant, error));
	}

	public String getReverseHistory() {
		StringBuffer result = new StringBuffer();
		result.append("<table border=\"1\">");
		result.append(WorkflowLog.getHeader());
		for (int i = lines.size() - 1; i > -1; i--)
			result.append(lines.get(i));
		result.append("</table>");
		return result.toString();
	}

	public String getHistory() {
		StringBuffer result = new StringBuffer();
		result.append("<table border=\"1\">");
		result.append(WorkflowLog.getHeader());
		Iterator i = lines.iterator();
		while (i.hasNext()) {
			WorkflowLog item = (WorkflowLog) i.next();
			result.append(item);
		}
		result.append("</table>");
		return result.toString();
	}
	
	public void clear(){
		lines.clear();
	}


}
