package web;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;


import ecommerce.Caddie;
import ecommerce.Client;
import framework.ActionContext;

public class CaddieAction {

	public static Caddie retrieve(int id, List<Caddie> caddies) {
		Iterator caddieIterator = caddies.iterator();
		while (caddieIterator.hasNext()) {
			Caddie caddie = (Caddie) caddieIterator.next();
			if (caddie.getId() == id)
				return caddie;
		}
		return null;
	}

	private static Caddie update(HttpServletRequest request, Caddie courant,
			Client client) {
		courant.setClient(client);
		String m = request.getParameter("montant");
		double montant = Double.parseDouble(m);
		courant.setMontant(montant);
		String date = request.getParameter("date");
		courant.setDate(date);
		return courant;
	}

	private static Caddie create(HttpServletRequest request,
			List<Caddie> caddies, Client client) {
		String m = request.getParameter("montant");
		double montant = Double.parseDouble(m);
		Caddie newCaddie = null;
		try {
			newCaddie = new Caddie(caddies.size() + 1, client, montant, "");
		} catch (Exception e) {
			System.out.print(e.getMessage());
		}
		if (newCaddie != null && newCaddie.getError() == null)
			caddies.add(newCaddie);
		return newCaddie;
	}

	private static Caddie delete(HttpServletRequest request, Caddie caddie,
			List<Caddie> caddies) {
		if (caddie != null)
			caddies.remove(caddie);
		return null;// on pourrait retourner le prcdent ou le premier
	}

	public static void action(ActionContext context) {
		int id = -2;
		int clientId = -2;
		if (context.getRequest().getParameter("id") != null)
			id = Integer.parseInt(context.getRequest().getParameter("id"));

		if (context.getRequest().getParameter("client") != null)
			clientId = Integer.parseInt(context.getRequest().getParameter(
					"client"));

		Client client = ClientAction.retrieve(clientId, context
				.getApplication().getClients());
		Caddie caddie = retrieve(id, client.getCaddies());
		List<Caddie> caddies = client.getCaddies();
		String action = null;
		try {
			if (caddie == null && id == -1)
				caddie = new Caddie(-1, client, 0.0, "");
			context.saveBeanIfClean(caddie); // ncessaire pour la gestion
			// des erreurs
			action = context.getAction();
			String priorAction = context.getPriorAction();
			if ("new".equals(action)) {
				caddie = new Caddie(-1, client, 0.0, "");
				context.setBean(caddie);
				context.setState("formcaddie.jsp");
			} else if ("delete".equals(action)) {
				context.setBean(caddie);
				context.setState("confirmcaddie.jsp");
			} else if ("cancel".equals(action)) {
				caddie = (Caddie) (context.cancel(caddies));
				context.setState("listecaddies.jsp");
			} else if ("list".equals(action)) {
				context.setBean(caddie);
				context.setState("listecaddies.jsp");
			} else if ("edit".equals(action)) {
				context.setBean(caddie);
				context.setState("formcaddie.jsp");
			} else if ("retour".equals(action)) {
				context.setBean(null);
				context.setState("formclient.jsp");
			} else if ("confirm".equals(action) && "edit".equals(priorAction)) {
				caddie.clearError();
				caddie = update(context.getRequest(), caddie, client);
				context.setBean(caddie);
				context.setState("listecaddies.jsp");
			} else if ("confirm".equals(action) && "new".equals(priorAction)) {
				caddie = create(context.getRequest(), caddies, client);
				context.setBean(caddie);
				context.setState("listecaddies.jsp");
			} else if ("confirm".equals(action) && "delete".equals(priorAction)) {
				caddie = delete(context.getRequest(), caddie, caddies);
				context.setBean(caddie);
				context.setState("listecaddies.jsp");
			} else if ("confirm".equals(action)) {
				context.setBean(caddie);
				context.setState("listecaddies.jsp");
			}
		} catch (Exception e) {
			context.setError(e.getMessage());
		}
		if ("retour".equals(action)) {
			context.getRequest().setAttribute("client", client);
			context.getRequest().setAttribute("codespostaux",
					context.getApplication().getCodesPostaux());
		}
		if (context.getBean() != null && context.getBean() instanceof Caddie)
			caddie = (Caddie) context.getBean();
		context.getRequest().setAttribute("listecaddies", caddies);
		context.getRequest().setAttribute("client", client);
		if (caddie == null)
			context.getRequest().removeAttribute("caddie");
		else
			context.getRequest().setAttribute("caddie", caddie);
	}

}
