package web;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import framework.ActionContext;
import ecommerce.Client;
import ecommerce.CodePostal;

public class ClientAction {

	private static CodePostal retrieve(int id, List<CodePostal> codesPostaux) {
		Iterator cpIterator = codesPostaux.iterator();
		while (cpIterator.hasNext()) {
			CodePostal cp = (CodePostal) cpIterator.next();
			if (cp.getId() == id)
				return cp;
		}
		return null;
	}

	public static Client retrieve(int id, List<Client> clients) {
		Iterator clientIterator = clients.iterator();
		while (clientIterator.hasNext()) {
			Client client = (Client) clientIterator.next();
			if (client.getId() == id)
				return client;
		}
		return null;
	}

	private static Client update(HttpServletRequest request, Client client,
			CodePostal codePostal) {
		client.setNom(request.getParameter("nom"));
		client.setAdresse(request.getParameter("adresse"));
		client.setCodePostal(codePostal);
		return client;
	}

	private static Client create(HttpServletRequest request,
			List<Client> clients, CodePostal codePostal) {
		Client newClient = new Client(clients.size() + 2, request
				.getParameter("nom"), request.getParameter("adresse"),
				codePostal);
		if (newClient != null && newClient.getError() == null)
			clients.add(newClient);
		return newClient;
	}

	private static Client delete(HttpServletRequest request, Client client,
			List<Client> clients) {
		if (client != null)
			clients.remove(client);
		return null;// on pourrait retourner le prcdent ou le premier
	}

	public static void action(ActionContext context) {
		int id = -2;
		int codePostalId = -2;
		if (context.getRequest().getParameter("id") != null)
			id = Integer.parseInt(context.getRequest().getParameter("id"));
		List<Client> clients = context.getApplication().getClients();
		Client client = retrieve(id, clients);

		if (context.getRequest().getParameter("codepostal") != null)
			codePostalId = Integer.parseInt(context.getRequest().getParameter(
					"codepostal"));

		CodePostal codePostal = retrieve(codePostalId, context.getApplication()
				.getCodesPostaux());

		String action = null;
		if (client == null && id == -1)
			client = new Client(-1, "", "", new CodePostal(-1, "", ""));
		try {
			context.saveBeanIfClean(client); // ncessaire pour la gestion
			// des erreurs
			action = context.getAction();
			String priorAction = context.getPriorAction();
			if ("new".equals(action)) {
				client = new Client(-1, "", "", new CodePostal(-1, "", ""));
				context.setBean(client);
				context.setState("formclient.jsp");
			} else if ("delete".equals(action)) {
				context.setBean(client);
				context.setState("confirmclient.jsp");
			} else if ("cancel".equals(action)) {
				client = (Client) (context.cancel(clients));
				context.setState("listeclients.jsp");
			} else if ("list".equals(action)) {
				context.setBean(client);
				context.setState("listeclients.jsp");
			} else if ("edit".equals(action)) {
				context.setBean(client);
				context.setState("formclient.jsp");
			} else if ("confirm".equals(action) && "edit".equals(priorAction)) {
				client.clearError();
				client = update(context.getRequest(), client, codePostal);
				context.setBean(client);
				context.setState("listeclients.jsp");
			} else if ("confirm".equals(action) && "new".equals(priorAction)) {
				client = create(context.getRequest(), clients, codePostal);
				context.setBean(client);
				context.setState("listeclients.jsp");
			} else if ("confirm".equals(action) && "delete".equals(priorAction)) {
				client = delete(context.getRequest(), client, clients);
				context.setBean(client);
				context.setState("listeclients.jsp");
			} else if ("confirm".equals(action)) {
				context.setBean(client);
				context.setState("listeclients.jsp");
			} else if ("detail".equals(action)) {
				context.setBean(client);
				context.setState("listecaddies.jsp");
			}
		} catch (Exception e) {
			context.setError(e.getMessage());
		}

		client = (Client) context.getBean();
		context.getRequest().setAttribute("listeclients", clients);
		context.getRequest().setAttribute("codespostaux",
				context.getApplication().getCodesPostaux());
		if (client == null)
			context.getRequest().removeAttribute("client");
		else
			context.getRequest().setAttribute("client", client);
	}
}
