package web;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

import ecommerce.Application;
import framework.ActionContext;
import framework.Controleur;

/**
 * 
 * @author gsi-4a
 * controleur unique spcialis de l'application
 *
 */

public class ECommerceControleur extends Controleur {
	private Application application = new Application();

	@Override
	public void init() throws ServletException {
		super.init();
		application.load();	
	}

	@Override
	public void destroy() {
		application.save();
		super.destroy();
	}	
	
	@Override
	protected void actions(String path,ActionContext c) {
		if ("client".equals(path))
			ClientAction.action(c);
		else if ("caddie".equals(path))
			CaddieAction.action(c);
		else if ("produit".equals(path))
			ProduitAction.action(c);
	}
	@Override
	protected void setContext(ActionContext context, HttpServletRequest request, String priorAction,String action,String etatCourant,String etatSuivant){
		context.initialize(request,application, priorAction, action, etatCourant,etatSuivant);	
	}
		

}
