package web;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import ecommerce.CodePostal;
import ecommerce.Produit;
import framework.ActionContext;

public class ProduitAction {

	public static Produit retrieve(int id, List<Produit> produits) {
		Iterator produitIterator = produits.iterator();
		while (produitIterator.hasNext()) {
			Produit produit = (Produit) produitIterator.next();
			if (produit.getId() == id)
				return produit;
		}
		return null;
	}

	private static Produit update(HttpServletRequest request, Produit produit) {
		produit.setNom(request.getParameter("nom"));
		produit.setPrix(Double.parseDouble(request.getParameter("prix")));
		return produit;
	}

	private static Produit create(HttpServletRequest request,
			List<Produit> produits) {
		Produit newProduit = new Produit(produits.size() + 1, request
				.getParameter("nom"), Double.parseDouble(request.getParameter("prix")));
		if (newProduit != null && newProduit.getError() == null)
			produits.add(newProduit);
		return newProduit;
	}

	private static Produit delete(HttpServletRequest request, Produit produit,
			List<Produit> produits) {
		if (produit != null)
			produits.remove(produit);
		return null;// on pourrait retourner le prcdent ou le premier
	}

	public static void action(ActionContext context) {
		int id = -2;
		if (context.getRequest().getParameter("id") != null)
			id = Integer.parseInt(context.getRequest().getParameter("id"));
		List<Produit> produits = context.getApplication().getProduits();
		Produit produit = retrieve(id, produits);
		String action = null;
		if (produit == null && id == -1)
			produit = new Produit(-1, "", 0.0);
		try {
			context.saveBeanIfClean(produit); // ncessaire pour la gestion
			// des erreurs
			action = context.getAction();
			String priorAction = context.getPriorAction();
			if ("new".equals(action)) {
				produit = new Produit(-1, "", 0.0);
				context.setBean(produit);
				context.setState("formproduit.jsp");
			} else if ("delete".equals(action)) {
				context.setBean(produit);
				context.setState("confirmproduit.jsp");
			} else if ("cancel".equals(action)) {
				produit = (Produit) (context.cancel(produits));
				context.setState("listeproduits.jsp");
			} else if ("list".equals(action)) {
				context.setBean(produit);
				context.setState("listeproduits.jsp");
			} else if ("edit".equals(action)) {
				context.setBean(produit);
				context.setState("formproduit.jsp");
			} else if ("confirm".equals(action) && "edit".equals(priorAction)) {
				produit.clearError();
				produit = update(context.getRequest(), produit);
				context.setBean(produit);
				context.setState("listeproduits.jsp");
			} else if ("confirm".equals(action) && "new".equals(priorAction)) {
				produit = create(context.getRequest(), produits);
				context.setBean(produit);
				context.setState("listeproduits.jsp");
			} else if ("confirm".equals(action) && "delete".equals(priorAction)) {
				produit = delete(context.getRequest(), produit, produits);
				context.setBean(produit);
				context.setState("listeproduits.jsp");
			} else if ("confirm".equals(action)) {
				context.setBean(produit);
				context.setState("listeproduits.jsp");
			} else if ("detail".equals(action)) {
				context.setBean(produit);
				context.setState("listecaddies.jsp");
			}
		} catch (Exception e) {
			context.setError(e.getMessage());
		}
		produit = (Produit) context.getBean();
		context.getRequest().setAttribute("listeproduits", produits);	
		if (produit == null)
			context.getRequest().removeAttribute("produit");
		else
			context.getRequest().setAttribute("produit", produit);
	}
}
